#!/usr/bin/env php
<?php

/*    запуск генерации всех файлов через командную строку php cli
        php generation.php
*/

define('DOCGEN', 1); // для защиты от прямого запуска php-файлов 

// если какой-то ключ совпадает, то его можно не указывать в файле страницы
$dataDefault = [
    'title' => '',
    'description' => '',
    'file' => 'output.html', // выходной файл
    'assetsDir' => 'assets/', // каталог для assets относительно doc/
];

$engineDir = __DIR__ . DIRECTORY_SEPARATOR;
$srcDir = dirname($engineDir) . DIRECTORY_SEPARATOR;
$docDir = dirname($srcDir) . DIRECTORY_SEPARATOR;

$srcFiles = glob($srcDir . '*.php');

foreach($srcFiles as $fn) {
        
    ob_start();
    require $fn;
    $content = ob_get_contents();
    if (ob_get_length()) ob_end_clean();
    
    $data = array_merge($dataDefault, $data);
    
    ob_start();
    require $srcDir . 'layout/menu.php';
    $menu = ob_get_contents();
    if (ob_get_length()) ob_end_clean();
    
    ob_start();
    require $srcDir . 'layout/main.php';
    $main = ob_get_contents();
    if (ob_get_length()) ob_end_clean();   
        
    file_put_contents( $docDir . $data['file'], $main);
    
    echo $data['file'] . " - OK\n";
}

# end of file
